#define MACINTOSH //mac

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <time.h>
#include <iostream>
#include <fstream>
#include <string>
#include <new>

#ifdef WINDOWS
#include "GL/glut.h"
#endif

#ifdef MACINTOSH
#include <GLUT/glut.h>
#endif    


// 球の解像度
#define N_IDO  36 //32 （12の倍数が好ましい（地球の一周が360度であり、3とか4で、きちんと割れることを考えると）。２の常数よりスピードは少し落ちる） 
#define N_KEIDO 72 //64（12の倍数が好ましい）

// テクスチャファイルの最大数
#define NUMBER_TEXTURE_FILE 2000

#define NUMBER_ICON_TEXTURE_FILE 18 // iconのテクスチャの数の最大値
#define NUMBER_ICON 14
// iconの表示数の最大値
#define NUMBER_EARTH 2 // 地球の表示数の最大値
#define INITJITEN 0.0 // 自転の初期値



#define LINE_KAKUDAI 1.007 // 経線、緯線のある場所。1で地表、大きくすると地表から離れる

/* GLUTメニュー識別用番号 */
#define APP_QUIT 1
#define APP_START 3
#define APP_PERSPEC 5
#define APP_FOG 6
#define APP_ANIM 8
#define APP_R_ANIM 9
#define APP_PRINT 12
#define APP_SCREEN 14
#define APP_JITEN 16
#define APP_INITTEXTURE 18

// テクスチャのイメージの情報を保存するクラス
class TexImage {
public:
	int width;
	int height;
	char* imageData;
	TexImage (){}
};


/* 画像 */
extern TexImage image1[NUMBER_TEXTURE_FILE];
extern TexImage image2[NUMBER_TEXTURE_FILE];
extern TexImage icon[NUMBER_ICON_TEXTURE_FILE];// playicon // stopicon // modoruicon
extern int icon_onoff[NUMBER_ICON];

extern int mask_logo[NUMBER_TEXTURE_FILE] ; //ロゴ画像があるかないか0無し1あり
/////////////////////
/* 光源の位置 */
extern GLfloat pos[] ; /* 光源の位置　　　 */

/* 視点の位置*/
extern GLdouble ex , ey, ez ;

/* 目標点の位置 */
extern GLdouble tx, ty, tz;

/* ドラッグ開始位置 */
extern int cx, cy;

/* マウスの絶対位置→ウィンドウ内での相対位置の換算係数 */
extern double sx, sy;

/* マウスの相対位置→回転角の換算係数 */
#define SCALE (2.0 * 3.14159265358979323846)

// マウスの相対位置→平行移動
#define XYSCALE 2.00

/* 回転の初期値 (クォータニオン) */
extern double cq[4];

/* ドラッグ中の回転 (クォータニオン) */
extern double tq[4];

/* 地球１と２のズレ (クォータニオン) */
extern double qzure[4],qzure_inv[4];

/* 回転の変換行列 */
extern double rt[16];
extern double rt2[16];
extern float rtglui[16];

extern GLfloat scale_factor;  /* スケーリング値（拡大率） */
extern GLfloat scale_factor2;  /* スケーリング値（拡大率） */
extern GLfloat init_scale_factor ;  /* スケーリング値（拡大率）の初期値 */
extern GLfloat init_scale_factor2 ;  /* スケーリング値（拡大率）の初期値 */
// スクリーンの大きさ
extern int pixsize_x ;
extern int pixsize_y ;



extern GLfloat trans[2]  ;
extern float trans_ary[2];
extern float trans_aryZ[];
extern GLfloat trans2[2]  ;
extern float trans_ary2[2];
extern float trans_aryZ2[];
extern float line_width  ;// 線（緯線、経線）の太さ
extern float line_width_red  ;// 赤道の太さ
extern GLfloat color_isenkeisen[4]; //緯線と経線の色
extern GLfloat color_sekidou[4] ; //赤道の色

extern int scaling ;// 1はスケーリングの変更中
extern int parallel; // 1は平行移動中
extern int fogornot; // 1はFOG処理がある
extern int fullscreen; // 1はフルスクリーン
extern int jitenornot; // 1は自転
extern int print_dame; // 1の場合、ファイルの書き出しができない
extern int stopornot; // 1は時間発展で最後までいったらくりかえす
extern int num_keisen ; // 経線での分割数、初期条件ファイルを読み込む
extern int num_isen ; // 緯線での分割数、初期条件ファイルを読み込む
extern int isenkeisenornot ; // 1の場合、経線や緯線を表示する
extern int readtextureornot ; // 1はテクスチャファイルを読み込む
extern int readtextureornot2 ; // 1はテクスチャファイルを読み込む（window2） 
extern int readinit_file ; // 1はinit_file、初期条件ファイルを読み込む
extern GLint fogMode ;

extern clock_t jikan1 ; //時間計測
extern clock_t jikan2 ; //時間計測
extern clock_t jitenjikan1 ; //時間計測
extern clock_t jitenjikan2 ; //時間計測
extern int gui_posi_x ,gui_posi_y ; // GUIの窓の初期位置
extern double anim_speed ; //アニメーション時にテクスチャを変更する時間間隔（秒）（標準値）
extern double anim_duration ; //再生ボタンを押してからのポーズ時間

extern double key_kaiten ; // キーボードでの回転角の調整
extern double jiten_speed ;//自転時に地球を回転する時間間隔（秒）（こっちは固定）
extern double jiten_kankaku ;//自転時に地球を回転する一回あたりの角度（360.0で一週）（標準値）
extern double rad_latitude ;// 緯度の初期値
extern double rad_longitude ;// 経度の初期値
extern double rad_latitude2 ;// 緯度の初期値
extern double rad_longitude2 ;// 経度の初期値
extern double thetajiten  ; // 自転角の初期値
extern double logo_scale  ; // ロゴの拡大率
extern double logo_x  ; // ロゴのx座標
extern double logo_y  ; // ロゴのy座標
extern double time_x ; // タイムバーのx座標
extern double time_y  ; // タイムバーのy座標
extern double time_scale  ; // タイムバーの拡大率
extern double thetajiten  ; // 自転角の初期値
extern double trans_x ; // 地球の初期のx座標
extern double trans_y  ; // 地球の初期のy座標
extern double trans_x2 ; // 地球2の初期の相対x座標
extern double trans_y2  ; // 地球2の初期の相対y座標
extern double angle_axis2[2] ; // 地球２の角度のずれの軸 (x,y)で指定。
extern double angle2; // 地球2の角度のず

extern double kansei_speed ;//慣性回転時に地球を回転する時間間隔（秒）（こっちは固定）
extern double minkanseikaiten ; //この値より変化が小さい場合は慣性による回転をしない（回転の次元）
extern double minkanseikaitenstop ;//この値よ変化が小さくなった場合は慣性による回転を止める（回転の次元）
extern double strengthkanseikaiten;//慣性回転の回転の速さ
extern double gensuikanseikaiten;// 慣性回転の減衰係数（1は減衰しない） 

extern int invisible_cursor;//


extern int ipad_frag ; // 1の場合ipad用
extern int animsokudo ; //初期値 {1~15}の値を取る
extern int jitensokudo ; //初期値 {1~15}の値を取る
extern int henka ;// コントロールパネルで速度を変えたときが 1

extern int guilevel ; // GUIのレベル
extern int int_button ;// ボタンファイルが有るかないか。1はある

extern double icon_scale[] ; // アイコンの大きさ
extern double icon_posi_x[]  ; // アイコンのx座標
extern double icon_posi_y[]  ; // アイコンのy座標
extern int nsphere ; // 表示する惑星の数
extern int synch ; // 惑星の平行移動、拡大縮小がシンクするかどうか 1はシンクする
extern int rotsynch ; // 惑星の回転がシンクロするかどうか 1はシンクする
extern int second_sphere_texture ; // テクスチャを惑星によって変更する場合は、1
extern int screen_front; // 1のとき、スクリーンが地球より前、0のとき、スクリーンが後ろ

extern std::string strtexfile ;
extern std::string strtexfile_s;
extern std::string strscreenfile;
extern std::string strscreenfile_s;
extern std::string strtexfile2 ;
extern std::string strtexfile_s2;
extern std::string strscreenfile2;
extern std::string strscreenfile_s2;
extern int tex_start ; // 最初のテクスチャの番号（ファイル名）
extern int tex_end ; // 最後のテクスチャの番号

extern char *buff2 ;   /* 文字列用 （後）コマンドライン引数がない場合の文字列*/


// gluOrthoの引数
extern GLdouble size_ortho ; // 領域の広さ（一番上が2、下が-2）

// gluPerspetiveの引数
extern GLdouble fovy ; // gluOrthoと同じ大きさ(z = 0の面で)
extern GLdouble nearlimit ; // 近くの制限 gluOrthoと共通
extern GLdouble farlimit ; // 遠くの制限 gluOrthoと共通


//初期設定ファイル

extern char* init_file[3] ; 

extern char logobuff[128];    /* 連結文字列用 */

extern char *logobuff2 ;   /* 文字列用 （後）コマンドライン引数がない場合の文字列*/
extern FILE *gazou_f[NUMBER_TEXTURE_FILE];
extern FILE *logogazou_f[NUMBER_TEXTURE_FILE];

void init_rotate(void);
void fog(void);
void idle(int);
void init_glut_menu(void);


extern int ntime; //時間の初期値

extern int ntimemax; //テクスチャの数（デフォルト）（時間の上限）。ファイル数によって自動的にntimemaxが決められる。
extern int ntimetmp ;

extern  int perspec; // 1はperspectiveに眺める
extern  int perspec_radio ; //ラジオボタン用
extern  int print ; // 1は画像をファイルに出力する
extern  int anim ; // 0 静止、1 テクスチャアニメーション 、-1　逆再生 

// 色の設定
extern GLfloat white[] ;
extern GLfloat gray[];
extern GLfloat darkgray[] ;
extern GLfloat green[] ;
extern GLfloat red[] ;
extern GLfloat blue[] ;

// 関数
void functimebar(void);
void display(void);
void display2(void);
void display_earth(int);
void resize(int , int );
void idle(int);
void spkeyboard(int , int , int );

void keyboard(unsigned char, int , int );
void mouse(int, int , int , int );

void motion(int , int );
static void app_menu_func(int);
static void menu_func(int);
void init_glut_menu(void);
void init_rotate(void);
void fog(void);
void init(int);

void cvtexture(void);
void guiglui(void);


void gluiUpdate(void);
void gluiSetscrollbar(int, int);
void gluiCallback(int ) ;
void gluiCallback2(int ) ;
void gluisaisei(int ) ;
void gluiteishi(int ) ;
void gluigyakusaisei(int) ;
void gluisaisyo(int ) ;
void gluihenka(int) ;
void scrollbar(int );
void gluitransz(int );
void gluirotate(int );
void gluireplace(int );
void gluioutput(int );
void gluitinitialtrans (int );


void func_readinit_file(void);
void fileyomitori (int);
void fileornot (void);
void func_readinit_file(void);
void texture_change(int);
void sphere(double );
void latitude_rotate(void);
void qmul(double r[], const double p[], const double q[]);
void qrot(double r[] , double q[]);
void qlatlong(double* theta1, double* theta2, const double q[]);

char* load_image(FILE*, int*, int*);
char* load_image_jpeg(FILE*, int*, int*);
char* load_image_jpeg_toumei(FILE*, int*, int*);
